#define UNICODE
#define _UNICODE

typedef unsigned * ULONG_PTR;
#include <windows.h>
#include <tchar.h>
#include <gdiplus.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include "mygraph.h"
#include "mygraphplus.h"
#include "math.h"
#include "float.h"
using namespace Gdiplus;
float pi2=6.283185307179586476925286766559f;
float pi=3.1415926535897932384626433832795f;
int cwidth = 0, cheight = 0;

	static float
		p1=0.78539816339744830961566084581988f,
		p2=1.5707963267948966192313216916398f,
		p3=2.3561944901923449288469825374596f,
		p4=3.1415926535897932384626433832795f,
		p5=3.9269908169872415480783042290994f,
		p6=4.7123889803846898576939650749193f,
		p7=5.4977871437821381673096259207391f,
		p8=6.283185307179586476925286766559f;


	int inline round(float f)
{
	return int(f+_copysign(0.5,f));
}

VOID OnGDIPlusSegment(HWND hWnd, int num, DWORD &tm, int width, int height) //    GDI+
{
	float a1=0.0f,a2=360.0f,step=360.0f/((height-1)*num);
	HDC hdc = GetDC(hWnd);	//   
	Graphics grfx(hdc);		//   Graphics
	Pen  pen(Color(255, 0, 0)); //   

	int x1, y1, x2, y2;
	DWORD tm1 = GetTickCount();	//     tm1
	for (int j = 0; j < num; j++)	//        num 
	for (int i = 0; i < height; i++)
	{
		//grfx.DrawLine(&pen, 0, i, width, i);
		grfx.DrawPie(&pen,0,0,height,height,a1,a2);
		a1+=step;
		a2-=step;
	}

	tm = GetTickCount(); //   ,   
	tm -= tm1;
	ReleaseDC(hWnd, hdc);

}

VOID OnGDIPlusBMPSegment(HWND hWnd, int num, DWORD &tm, int width, int height)
{
	float a1=0.0f,a2=360.0f,step=360.0f/((height-1)*num);
	HDC hdc = GetDC(hWnd);	//   
	Graphics grfx(hdc);		//   Graphics
	Bitmap *bmp = new Bitmap(width, height);	//   Bitmap
	Graphics gbmp(bmp);		//   Graphics,   Bitmap-
	Pen  pen(Color(255, 0, 0));	//   

	int x1, y1, x2, y2;
	DWORD tm1 = GetTickCount();
	for (int j = 0; j < num; j++)
	for (int i = 0; i < height; i++)
	{
		//gbmp.DrawLine(&pen, 0, i, width, i);	//    Bitmap-
		gbmp.DrawPie(&pen,0,0,height,height,a1,a2);
		a1+=step;
		a2-=step;
	}
	grfx.DrawImage(bmp, 0, 0);	//   Bitmap-  
	tm = GetTickCount();
	tm -= tm1;
	ReleaseDC(hWnd, hdc);
	delete bmp;
}

 VOID OnGDIPlusBMPOwnDrawSegment(HWND hWnd, int num, DWORD &tm, int width, int height)
{
	int midx=width/2,midy=height/2;
	float a1=0.0f,a2=pi2,step=pi2/(height*num);
	HDC hdc = GetDC(hWnd);
	Graphics grfx(hdc);
	Bitmap *bmp = new Bitmap(width, height);
	Graphics gbmp(bmp);
	Pen  pen(Color(255, 255, 0));
	int x1, y1, x2, y2;
	UINT* pixels;
	BitmapData bitmapData;
	Rect rect(0, 0, width, height);
	DWORD tm1 = GetTickCount();
	bmp->LockBits(				//        Bitmap-
      &rect,
      ImageLockModeWrite,
      PixelFormat32bppARGB,
      &bitmapData);

   
   pixels = (UINT*)bitmapData.Scan0;	//      

	for (int j = 0; j < num; j++)
	for (int i = 0; i < height; i++)
	{
		/*for (int k = 0; k < width; k++)
		{
			pixels[i * bitmapData.Stride / 4 + k] = 0xffffff00; //	 32-         
		}*/
		MySegmentPlus(pixels,bitmapData.Stride / 4,midx,midy,midy-5,a1,a2,0xffffff00);
		a1+=step;
		a2-=step;
	}
	bmp->UnlockBits(&bitmapData);	//    
	grfx.DrawImage(bmp, 0, 0);		//   Bitmap-
	tm = GetTickCount();
	tm -= tm1;
	ReleaseDC(hWnd, hdc);
	delete bmp;
}


VOID OnGDISegment(HWND hWnd, int num, DWORD &tm, int width, int height)
{
	int xs,ys,xe,ye;int r=height;
	float a1=0.0f,a2=pi2,step=pi2/(height*num);
	HDC hdc = GetDC(hWnd);
	HPEN hPen = CreatePen (PS_SOLID, 1, RGB (0, 255, 0));	//    
	SelectObject(hdc, hPen);		//     
	//SelectObject(hdc,GetStockObject(NULL_BRUSH));
	int x1, y1, x2, y2;
	DWORD tm1 = GetTickCount();
	for (int j = 0; j < num; j++)
	for (int i = 0; i < height; i++)
	{
		//MoveToEx(hdc, 0, i, (LPPOINT)NULL);
		//LineTo(hdc, width, i);
		//Rectangle(hdc,0,0,width,height);
	if (((a1>p1)&&(a1<p3)) || ((a1>p5)&&(a1<p7)))
	{
		ys=-round(cos(a1)*r);
		xs=-round(sqrt(r*r-ys*ys));
		if (a1>p4) xs=-xs;
	}
	else
	{
		xs=round(sin(a1)*r);
		ys=-round(sqrt(r*r-xs*xs));
		if ((a1>p2)&&(a1<p6)) ys=-ys;
	}
	if (((a2>p1)&&(a2<p3)) || ((a2>p5)&&(a2<p7)))
	{
		ye=-round(cos(a2)*r);
		xe=-round(sqrt(r*r-ye*ye));
		if (a2>p4) xe=-xe;
	}
	else
	{
		xe=round(sin(a2)*r);
		ye=-round(sqrt(r*r-xe*xe));
		if ((a2>p2)&&(a2<p6)) ye=-ye;
	}


		Pie(hdc,0,0,height,height,xs,ys,xe,ye);
		
		a1+=step;
		a2-=step;
	}
	tm = GetTickCount();
	tm -= tm1;
	ReleaseDC(hWnd, hdc);
}

VOID OnMyGDISegment(HWND hWnd, int num, DWORD &tm, int width, int height)
{
	int midx=width/2,midy=height/2;
	float a1=0.0f,a2=pi2,step=pi2/((height-1)*num);
	HDC hdc = GetDC(hWnd);
	HPEN hPen = CreatePen (PS_SOLID, 1, RGB (0, 0, 255));
	SelectObject(hdc, hPen);
	int x1, y1, x2, y2;
	DWORD tm1 = GetTickCount();
	for (int j = 0; j < num; j++)
	for (int i = 0; i < height; i++)
	{
		//for (int k = 0; k < width; k++)	
		//SetPixel(hdc, k, i, RGB(0, 0, 255));	//       SetPixel
		MySegment(hdc,midx,midy,midy,a1,a2,0x0000FF00);
		a1+=step;
		a2-=step;
	}
	tm = GetTickCount();
	tm -= tm1;
	ReleaseDC(hWnd, hdc);
}

VOID OnGDIBMPSegment(HWND hWnd, int num, DWORD &tm, int width, int height)
{
	int xs,ys,xe,ye;int r=height;
	float a1=0.0f,a2=p8,step=p8/(height*num);
	HDC hdc = GetDC(hWnd);
	int x1, y1, x2, y2;
	BITMAP	bm;
	HDC	hdcMem;
	DWORD	dwSize;
	POINT	ptSize, ptOrg;
	HBITMAP hBitmap;
	
	DWORD tm1 = GetTickCount();	
	hBitmap = CreateCompatibleBitmap(hdc, width, height);	//  Bitmap-,       
	hdcMem = CreateCompatibleDC (hdc);	//     ,   .. 
	SelectObject (hdcMem, hBitmap);		//   ..     
	SetMapMode (hdcMem, GetMapMode (hdc));	//    hdcMem    hdc
	HPEN hPen = CreatePen (PS_SOLID, 1, RGB (0, 255, 0));	//    
	SelectObject(hdcMem, hPen);		//       
	SelectObject(hdcMem,GetStockObject(NULL_BRUSH));

	for (int j = 0; j < num; j++)
	for (int i = 0; i < height; i++)
	{
		//MoveToEx(hdcMem, 0, i, (LPPOINT)NULL);
		//LineTo(hdcMem, width, i);
		if (((a1>p1)&&(a1<p3)) || ((a1>p5)&&(a1<p7)))
		{
			ys=-round(cos(a1)*r);
			xs=-round(sqrt(r*r-ys*ys));
			if (a1>p4) xs=-xs;
		}
		else	
		{
			xs=round(sin(a1)*r);
			ys=-round(sqrt(r*r-xs*xs));
			if ((a1>p2)&&(a1<p6)) ys=-ys;
		}
		if (((a2>p1)&&(a2<p3)) || ((a2>p5)&&(a2<p7)))
		{
			ye=-round(cos(a2)*r);
			xe=-round(sqrt(r*r-ye*ye));
			if (a2>p4) xe=-xe;
		}
		else
		{
			xe=round(sin(a2)*r);
			ye=-round(sqrt(r*r-xe*xe));
			if ((a2>p2)&&(a2<p6)) ye=-ye;
		}
		Pie(hdcMem,0,0,height,height,xs,ys,xe,ye);
		a1+=step;
		a2-=step;
	}
	
	GetObject (hBitmap, sizeof (BITMAP), (LPVOID) &bm);	//    
	ptSize.x = bm.bmWidth;
	ptSize.y = bm.bmHeight;
	DPtoLP (hdc, &ptSize, 1);
	ptOrg.x = 0;				//    
	ptOrg.y = 0;
	DPtoLP (hdcMem, &ptOrg, 1);
	//   ..    .. 
	BitBlt (hdc, 0, 0, ptSize.x, ptSize.y,	
		 hdcMem, ptOrg.x, ptOrg.y, SRCCOPY);
	DeleteDC (hdcMem);
	tm = GetTickCount();
	tm -= tm1;	
	ReleaseDC(hWnd, hdc);
}

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

INT WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, PSTR, INT iCmdShow)
{
   HWND                hWnd;
   MSG                 msg;
   WNDCLASS            wndClass;
   GdiplusStartupInput gdiplusStartupInput;
   ULONG_PTR           gdiplusToken;
   
   //  GDI+.
   GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
   
   wndClass.style          = CS_HREDRAW | CS_VREDRAW;
   wndClass.lpfnWndProc    = WndProc;
   wndClass.cbClsExtra     = 0;
   wndClass.cbWndExtra     = 0;
   wndClass.hInstance      = hInstance;
   wndClass.hIcon          = LoadIcon(NULL, IDI_APPLICATION);
   wndClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
   wndClass.hbrBackground  = (HBRUSH)GetStockObject(GRAY_BRUSH);
   wndClass.lpszMenuName   = NULL;
   wndClass.lpszClassName  = TEXT("GettingStarted");
   
   RegisterClass(&wndClass);
   
   hWnd = CreateWindow(
      TEXT("GettingStarted"),   // window class name
      TEXT("Getting Started"),  // window caption
      WS_OVERLAPPEDWINDOW,      // window style
      CW_USEDEFAULT,            // initial x position
      CW_USEDEFAULT,            // initial y position
      CW_USEDEFAULT,            // initial x size
      CW_USEDEFAULT,            // initial y size
      NULL,                     // parent window handle
      NULL,                     // window menu handle
      hInstance,                // program instance handle
      NULL);                    // creation parameters
	  
   ShowWindow(hWnd, iCmdShow);
   UpdateWindow(hWnd);
   SetTimer(hWnd,1,350,NULL);
   while(GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   
   //   GDI+
   GdiplusShutdown(gdiplusToken);
   return msg.wParam;
}  // WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, 
   WPARAM wParam, LPARAM lParam)
{
   HDC          hdc;
   PAINTSTRUCT  ps;
   DWORD tm;
   TCHAR ch;
   TCHAR st[200];
   TCHAR title[200];
   double timeOne;
   switch(message)
   {
   case WM_PAINT:
      hdc = BeginPaint(hWnd, &ps);
	  //Pie(hdc,100,100,200,200,100,200,200,100);
	  EndPaint(hWnd, &ps);
      return 0;
   case WM_TIMER:
	   {
		   
	   hdc=GetDC(hWnd);
	   RECT rc;
	   GetClientRect(hWnd,&rc);

	   Rectangle(hdc,rc.left,rc.top,rc.right,rc.bottom );
	   MyCircle(hdc,100,100,50);
	   static int y1=10;
	   y1++;
	   LineBres(hdc,20,10,10,110,0);
	   static float a1=0.78539816339744830961566084581988f*4;
	   a1=a1-0.05f;
	   static float a2=0.78539816339744830961566084581988f*4;
	   a2=a2+0.05f;
	   a1=0.4; a2=0.5;
	   MySegment(hdc,400,400,200,a1,a2,0);
	   ReleaseDC(hWnd,hdc);
	   }
	break;
   case WM_SIZE:	//    
	   cwidth = LOWORD (lParam) ; //    
       cheight = HIWORD (lParam) ;//    
	   return 0;
   case WM_CHAR:	//   
	   ch = (char)wParam;	//   
/*+*/  if (ch == 'p')	//    GDI+
	   {
			OnGDIPlusSegment(hWnd, 100, tm, cwidth, cheight);
			_tcscpy(title, TEXT(" GDI+"));
			timeOne = 1.0*tm/100;
	   }
/*+*/  if (ch == 'g') //    GDI
	   {
		   OnGDISegment(hWnd, 100, tm, cwidth, cheight);
		   _tcscpy(title, TEXT(" GDI"));
		   timeOne = 1.0*tm/100;
	   }
/*+*/  if (ch == 'm')	//      SetPixel
	   {
		   OnMyGDISegment(hWnd, 1, tm, cwidth, cheight);
		   _tcscpy(title, TEXT("   . GDI"));
		   timeOne = 1.0*tm/1;
	   }
/*+*/ if (ch == 'b')	//    GDI+,      Bitmap
	   {
		   OnGDIPlusBMPSegment(hWnd, 100, tm, cwidth, cheight);
		   _tcscpy(title, TEXT(" GDI+  Bitmap"));
		   timeOne = 1.0*tm/100;
	   }
/*+*/  if (ch == 'o')	//    GDI+,  . .  Bitmap     
	   {
		   OnGDIPlusBMPOwnDrawSegment(hWnd, 100, tm, cwidth, cheight);
		   _tcscpy(title, TEXT("   Bitmap,  . GDI+"));
		   timeOne = 1.0*tm/100;
	   }
/*+*/  if (ch == 'f')	//    GDI,  . .  Bitmap     
	   {
		   OnGDIBMPSegment(hWnd, 100, tm, cwidth, cheight);
		   _tcscpy(title, TEXT("  Bitmap,  . GDI"));
		   timeOne = 1.0*tm/100;
	   }
	   _stprintf(st, TEXT("Time: %5.4f    "), timeOne);
	   MessageBox(hWnd, st, title, MB_OK);
	   //wsprintf(st,TEXT("  %u "),tm);
	   //MessageBox(hWnd,st,title,MB_OK);
	   return 0;
   case WM_DESTROY:
      PostQuitMessage(0);
      return 0;
   default:
      return DefWindowProc(hWnd, message, wParam, lParam);
   }
} // WndProc